package org.wiztools.oembed;

import java.io.IOException;
import java.io.InputStream;
import java.nio.charset.Charset;

/**
 * All implementations of oEmbed parsing implements this interface.
 * @author subhash
 */
public interface OEmbedParser {
    /**
     * 
     * @param is The oEmbed XML/JSON as stream.
     * @param charset The charset to be used for reading the stream.
     * @return The response.
     * @throws IOException When the stream-read has IO issues.
     * @throws OEmbedException On any other issues like parsing failure.
     */
    OEmbedResponse getResponse(InputStream is, Charset charset)
            throws IOException, OEmbedException;
}
